//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializelistLeaderboardEntriesResponse")
inline fun listLeaderboardEntriesResponse(block: gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponseKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse =
  gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponseKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse.newBuilder()).apply { block() }._build()
object ListLeaderboardEntriesResponseKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse = _builder.build()

    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class LeaderboardEntriesProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     */
     val leaderboardEntries: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>
      @kotlin.jvm.JvmSynthetic
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getLeaderboardEntriesList()
      )
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     * @param value The leaderboardEntries to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addLeaderboardEntries")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.add(value: gg.dsepractice.chinese.v1alpha1.LeaderboardEntry) {
      _builder.addLeaderboardEntries(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     * @param value The leaderboardEntries to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignLeaderboardEntries")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.LeaderboardEntry) {
      add(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     * @param values The leaderboardEntries to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllLeaderboardEntries")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry>) {
      _builder.addAllLeaderboardEntries(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     * @param values The leaderboardEntries to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllLeaderboardEntries")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry>) {
      addAll(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     * @param index The index to set the value at.
     * @param value The leaderboardEntries to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setLeaderboardEntries")
    operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.LeaderboardEntry) {
      _builder.setLeaderboardEntries(index, value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.LeaderboardEntry leaderboard_entries = 1 [json_name = "leaderboardEntries"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearLeaderboardEntries")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.LeaderboardEntry, LeaderboardEntriesProxy>.clear() {
      _builder.clearLeaderboardEntries()
    }

    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    var paginationInfo: gg.dsepractice.chinese.v1alpha1.PaginationInfo
      @JvmName("getPaginationInfo")
      get() = _builder.getPaginationInfo()
      @JvmName("setPaginationInfo")
      set(value) {
        _builder.setPaginationInfo(value)
      }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    fun clearPaginationInfo() {
      _builder.clearPaginationInfo()
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     * @return Whether the paginationInfo field is set.
     */
    fun hasPaginationInfo(): kotlin.Boolean {
      return _builder.hasPaginationInfo()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse.copy(block: gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponseKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponse =
  gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponseKt.Dsl._create(this.toBuilder()).apply { block() }._build()

val gg.dsepractice.chinese.v1alpha1.ListLeaderboardEntriesResponseOrBuilder.paginationInfoOrNull: gg.dsepractice.chinese.v1alpha1.PaginationInfo?
  get() = if (hasPaginationInfo()) getPaginationInfo() else null

